---
title: 'Window: rejectionhandled event'
slug: Web/API/Window/rejectionhandled_event
tags:
  - API
  - Event
  - HTML DOM
  - JavaScript
  - Promise
  - Promises
  - Reference
  - Window
  - Worker
  - events
  - global
  - onrejectionhandled
  - rejectionhandled
---
<div>{{APIRef("HTML DOM")}}</div>

<p><span class="seoSummary">The <strong><code>rejectionhandled</code></strong> event is sent to the script's global scope (usually {{domxref("window")}} but also {{domxref("Worker")}}) whenever a JavaScript {{jsxref("Promise")}} is rejected but after the promise rejection has been handled.</span> This can be used in debugging and for general application resiliency, in tandem with the {{domxref("Window.unhandledrejection_event", "unhandledrejection")}} event, which is sent when a promise is rejected but there is no hander for the rejection.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("PromiseRejectionEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("WindowEventHandlers.onrejectionhandled", "onrejectionhandled")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<p>You can use the <code>rejectionhandled</code> event to log promises that get rejected to the console, along with the reasons why they were rejected:</p>

<pre class="brush: js">window.addEventListener("rejectionhandled", event =&gt; {
  console.log("Promise rejected; reason: " + event.reason);
}, false);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'webappapis.html#unhandled-promise-rejections', 'rejectionhandled')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Window.rejectionhandled_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{SectionOnPage("/en-US/docs/Web/JavaScript/Guide/Using_promises", "Promise rejection events")}}</li>
 <li>{{domxref("PromiseRejectionEvent")}}</li>
 <li>{{jsxref("Promise")}}</li>
 <li>{{domxref("Window/unhandledrejection_event", "unhandledrejection")}}</li>
</ul>
